### Hierarchy

- BaseForLines
  - SimpleRuleGroup
    - SimpleRuleLoop

### Implements

- IRule

## Index

### Constructors

- constructor

### Properties

- __coverageCount
- __source
- isRandom

### Methods

- __getLineAndColumnRange
- __getSourceLineAndColumn
- __incrementCoverage
- addCellsToEmptyRules
- clearCaches
- evaluate
- getChildRules
- hasMatches
- hasRigid
- isLate
- toKey
- toSourceString
- toString

## Constructors

### constructor

- new SimpleRuleGroup(source: IGameCode, isRandom: boolean, rules: IRule[]): SimpleRuleGroup

- Overrides BaseForLines.constructor

  - Defined in models/rule.ts:107

  #### Parameters

  - ##### source: IGameCode

  - ##### isRandom: boolean

  - ##### rules: IRule[]

  #### Returns SimpleRuleGroup

## Properties

### __coverageCount

__coverageCount: Optional<number>

Implementation of IRule.__coverageCount

Inherited from BaseForLines.__coverageCount

- Defined in models/BaseForLines.ts:69

### __source

__source: IGameCode

Implementation of IRule.__source

Inherited from BaseForLines.__source

- Defined in models/BaseForLines.ts:68

### isRandom

isRandom: boolean

- Defined in models/rule.ts:106

## Methods

### __getLineAndColumnRange

- __getLineAndColumnRange(): object

- Implementation of IRule.__getLineAndColumnRange

  Inherited from BaseForLines.__getLineAndColumnRange

  - Defined in models/BaseForLines.ts:96

  #### Returns object

  - ##### end: object

    - ##### col: number

    - ##### line: number

  - ##### start: object

    - ##### col: number

    - ##### line: number

### __getSourceLineAndColumn

- __getSourceLineAndColumn(): object

- Implementation of IRule.__getSourceLineAndColumn

  Inherited from BaseForLines.__getSourceLineAndColumn

  - Defined in models/BaseForLines.ts:81

  #### Returns object

  - ##### colNum: number

  - ##### line: string

  - ##### lineNum: number

  - ##### nextLine: null | string

  - ##### prevLine: null | string

### __incrementCoverage

- __incrementCoverage(): void

- Inherited from BaseForLines.__incrementCoverage

  - Defined in models/BaseForLines.ts:104

  #### Returns void

### addCellsToEmptyRules

- addCellsToEmptyRules(cells: Iterable<Cell>): void

- - Defined in models/rule.ts:224

  #### Parameters

  - ##### cells: Iterable<Cell>

  #### Returns void

### clearCaches

- clearCaches(): void

- - Defined in models/rule.ts:201

  #### Returns void

### evaluate

- evaluate(level: Level, onlyEvaluateFirstMatch: boolean): IMutation[]

- - Defined in models/rule.ts:123

  #### Parameters

  - ##### level: Level

  - ##### onlyEvaluateFirstMatch: boolean

  #### Returns IMutation[]

### getChildRules

- getChildRules(): IRule[]

- - Defined in models/rule.ts:207

  #### Returns IRule[]

### hasMatches

- hasMatches(level: Level): boolean

- - Defined in models/rule.ts:114

  #### Parameters

  - ##### level: Level

  #### Returns boolean

### hasRigid

- hasRigid(): boolean

- - Defined in models/rule.ts:216

  #### Returns boolean

### isLate

- isLate(): boolean

- - Defined in models/rule.ts:211

  #### Returns boolean

### toKey

- toKey(): string

- Implementation of IRule.toKey

  - Defined in models/rule.ts:229

  #### Returns string

### toSourceString

- toSourceString(): string

- Implementation of IRule.toSourceString

  Inherited from BaseForLines.toSourceString

  - Defined in models/BaseForLines.ts:90

  #### Returns string

### toString

- toString(): string

- Implementation of IRule.toString

  Inherited from BaseForLines.toString

  - Defined in models/BaseForLines.ts:85

  #### Returns string

Generated using TypeDoc